﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        ObservableCollection<Manufacturer> Manufacturers;
        public MainPage()
        {
            InitializeComponent();
            CreateData();
            myTreeMap.ItemsSource = Manufacturers;

        }

        private void CreateData()
        {
            Manufacturers = new ObservableCollection<Manufacturer>();
            Random r = new Random();
            for (int i = 0; i < 5; i++)
            {
                double d = r.NextDouble();
                Manufacturer m = new Manufacturer()
                {
                    Name = "Manufacturer " + i.ToString(),
                    Revenue = d,
                    Products = new ObservableCollection<Product>()

                };
                int n = r.Next(11);
                for (int j = 0; j < n; j++)
                {
                    Product p = new Product()
                    {
                        Name = "Product" + i.ToString() + j.ToString(),
                        UnitsSold = r.Next(100), ProductStatus = r.Next(3)
                    };
                    m.Products.Add(p);
                }

                Manufacturers.Add(m);
            }
        }

        private void myTreeMap_NodeMouseRightButtonDown(object sender, Infragistics.Controls.Charts.TreemapNodeClickEventArgs e)
        {
            if (e.Node.DataContext is Manufacturer)
            {
                Manufacturer m = (Manufacturer)e.Node.DataContext;

                MessageBox.Show("This manufacture has " + m.Products.Count() + " products");
            }
            if (e.Node.DataContext is Product)
            {
                Product p = (Product) e.Node.DataContext;
                MessageBox.Show("The product status is " + p.ProductStatus);
            }
        }

        private void myTreeMap_NodeMouseLeftButtonDown(object sender, Infragistics.Controls.Charts.TreemapNodeClickEventArgs e)
        {
            XamTreemap treemap = (XamTreemap)sender;

            if (treemap.ItemsSourceRoot != e.Node.DataContext)
            {
                treemap.ItemsSourceRoot = e.Node.DataContext;
            }
        }
    }
}
