﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace SilverlightApplication1
{
    public class Manufacturer: INotifyPropertyChanged
    {
        public string Name { get; set; }
        public double Revenue
        {
            get { return _revenue; }
            set
            {
                if (_revenue != value)
                {
                    _revenue = value;
                    OnPropertyChanged("Revenue");
                }
            }
        }

        public ObservableCollection<Product> Products
        {
            get { return _products; }
            set
            {
                if (_products != value)
                {
                    _products = value;
                    OnPropertyChanged("Products");
                }
            }
        }
        

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private double _revenue;
        private ObservableCollection<Product> _products;
    }

    public class Product : INotifyPropertyChanged
    {
        public string Name { get; set; }
        public int UnitsSold
        {
            get { return _unitsSold; }
            set
            {
                if (_unitsSold != value)
                {
                    _unitsSold = value;
                    OnPropertyChanged("UnitsSold");
                }
            }
        }
        public int ProductStatus
        {
            get { return _productStatus; }
            set
            {
                if (_productStatus != value)
                {
                    _productStatus = value;
                    OnPropertyChanged("ProductStatus");
                }
            }
        }
        private int _unitsSold;
        private int _productStatus;
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

       
    }
}
